/*****************************************************************
 * PTlink IRCd is (C) CopyRight PTlink Coders Team 1999-2000     *
 * http://www.ptlink.net/Coders - coders@PTlink.net              *
 * This program is distributed under GNU Public License          *
 * Please read the file COPYING for copyright information.       *
 *****************************************************************
 *   $Id: spoof.c,v 1.4 2001/02/10 19:00:43 jpinto Exp $ 
 
  File: spoof.c
  Desc: host spoofing routines
  Author: Lamego@PTlink.net
*/

/* Patch for CN6.x - Spoofing Support
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * Copyright (c) 2002 Rodrigo Gimnez
 * All rights reserved.
 * Contact me at: kyotou@jpchat.net
 */

#include "struct.h"
#include "sys.h"
#include "numeric.h"
#include "msg.h"
#include "channel.h"
#include "throttle.h"
#include "h.h"
#include "spoof.h"
#include "ircsprintf.h"
#include "common_1.h"
int tagcount = 0;
#define MAXVIRTSIZE     (3 + 5 + 1)
#define HASHVAL_TOTAL   30011
#define HASHVAL_PARTIAL 211
#define HOSTPREFIX "CN"

void truncstring(char *stringvar, int firstlast, int amount);
int Maskchecksum (char *data, int len);
unsigned z(char *s);
void remove_dots_and_slashes(char* msg);
int str2array(char **pparv, char *string, char *delim);

/*
 * spoofed
 *
 * inputs       - client to be spoofed
 * output       - spoofed hostname
 * side effects -
 */

char *spoofed(aClient *acptr)
{
	  return maskme(acptr->user->host);
}

#define B_BASE                  0x1000
void truncstring(char *stringvar, int firstlast, int amount){
   if (firstlast)
   {
    stringvar+=amount;
    *stringvar=0;
    stringvar-=amount;
   }
    else
   {
    stringvar+=strlen(stringvar);
    stringvar-=amount;
   }
}

int Maskchecksum (char *data, int len)
{
        int                     i;
        int                     j;

        j=0;
        for (i=0 ; i<len ; i++)
        {
          j += *data++ * (i < 16 ? (i+1)*(i+1) : i*(i-15));

        }

        return (j+1000)%0xffff;
}

unsigned z(char *s)
{
    unsigned int i;
        i = Maskchecksum (s, strlen(s));
    return i;
}

int str2array(char **pparv, char *string, char *delim)
{
    char *tok;
    int pparc = 0;

    tok = strtok(string, delim);
    while (tok != NULL) {
	pparv[pparc++] = tok;
	tok = strtok(NULL, delim);
    }

    return pparc;
}


char *maskme(char *curr)
{
    static char mask[HOSTLEN + 1] = "";
    unsigned hash_total = z(curr) % HASHVAL_TOTAL, hash_partial;
    char     destroy[HOSTLEN+1], *parv[HOSTLEN+1], *ptr;
    int      parc=0, len=0, overflow=0, i=0;
/*    char premask[HOSTLEN + 1] = "";*/

    strncpy(destroy, curr, HOSTLEN);

    len = strlen(destroy);

    if ((len + MAXVIRTSIZE) > HOSTLEN)
    {
        overflow = (len + MAXVIRTSIZE) - HOSTLEN;

        ptr = &destroy[overflow];
    }
    else
        ptr = &destroy[0];
    if(!strchr(curr,'.')) {
    	strncpy(mask, curr, HOSTLEN);
    	return mask;
    }    
    parc = str2array(parv, ptr, ".");
    if (parc == 4)
    {
        len = strlen(parv[3]);

        if (IsDigit(parv[3][len-1]))
        {
            hash_partial = (z(parv[0])+z(parv[1])+z(parv[2])) % HASHVAL_PARTIAL;
            ircsprintf(mask, "%s.%s.%u.%u",
                parv[0], parv[1], hash_partial, hash_total);
            return mask;
        }
    }
    if (parc == 2)
    {
        ircsprintf(mask, "%s-%u.%s.%s",
            HOSTPREFIX, hash_total, parv[parc-2], parv[parc-1]);
        return mask;
    }
    if (parc >= 3)
    {
        ircsprintf (mask, "%s-%u", HOSTPREFIX, hash_total);
	for (i = 1;i<parc;i++) ircsprintf(mask, "%s.%s", mask, parv[i]);
        return mask;
    }
    len = strlen(parv[parc-1]);
    if (len == 2)
    {
        ircsprintf(mask, "%s-%u.%s.%s", /* Fixes spoofing - Lamego 1999*/
            HOSTPREFIX, hash_total, parv[parc-2], parv[parc-1]);	
        return mask;
    }
    ircsprintf(mask, "%s-%u.%s.%s", me.name, hash_total, parv[parc-2], parv[parc-1]);
    return mask;
}

/* BCRYPT */
void remove_dots_and_slashes(char* msg) {
  char temp[HOSTLEN+1];
  int i,j;
  strcpy(temp, msg);
  for(i = j = 0; i < strlen(temp); i++,j++) {
    if(temp[i] == '.') {
      msg[j++] = 'p'; msg[j] = 'p';
   } else if (temp[i] == '/') {
      msg[j++] = 'b'; msg[j] = 'b';
    } else
      msg[j] = temp[i];
  }
  msg[j] = 0;
}
